assert(MODULWARE, "ware lib errored!")
assert(MODULMAPPOS, "mappos lib errored!")
assert(MODULBASE, "minigamesbase errored!")
assert(MODULMINI1, "minigames1 errored!")
assert(MODULMINI2, "minigames2 errored!")
assert(MODULMINI3, "minigames3 errored!")
assert(MODULMINIB, "minigamesboss errored!")

local function recursiveTableContents(dw, pos, t, level)
	if level == nil then level = 0 end
	for k,v in pairs(t) do
		local str = type(v)
		
		if str == "number" or str == "string" then str = v
		elseif str == "boolean" then str = v and "true" or "false" end
		
		dw.drawString(pos.x, pos.y, string.rep("  ",level)..k.." \131"..str, V_ALLOWLOWERCASE, "small")
		pos.y = $+4
		
		if type(v) == "table" then
			if not v._RECURSIVEHIDE then
				recursiveTableContents(dw, pos, v, level+1)
			else
				dw.drawString(pos.x, pos.y, string.rep("  ",level+1).."\131".."hidden", V_ALLOWLOWERCASE, "small")
				pos.y = $+4
			end
		end
	end
end

local rndx = 320/2*FRACUNIT
local rndy = (200-80)*FRACUNIT

local stty = (200-60)*FRACUNIT

local prpx,prpy = 160*FRACUNIT,42*FRACUNIT

local scaleply = {
	{"actionspd"   ,   SCALE_PART, FRACUNIT*2/3},
	--{"mindash"     ,   SCALE_PART, },
	--{"maxdash"     ,   SCALE_PART, },
	{"normalspeed" ,   SCALE_PART, FRACUNIT},
	{"runspeed"    ,   SCALE_PART, FRACUNIT},
	{"jumpfactor"  ,   SCALE_NONE, },
	--{"thrustfactor",   SCALE_PART, },
	{"accelstart"  ,   SCALE_PART, FRACUNIT},
	{"acceleration",   SCALE_PART, FRACUNIT},
}

local debugtables = CV_RegisterVar({"ware_debugtables", 0, 0, CV_YesNo})
local funnycolor = {SKINCOLOR_RED, SKINCOLOR_YELLOW, SKINCOLOR_SAPPHIRE}
local scorecolor = {
	[GT_WARE] = SKINCOLOR_GOLD,
	[GT_WARECUSTOM] = SKINCOLOR_YELLOW,
	[GT_WAREDEBUG] = SKINCOLOR_WHITE
}

local emptyfunc = function() end
local WARESTATES = {
	// What's better than a fucking massive elseif?
	// That's right, a fucking lookup table
	global = {
		gamehud = function(v,p,c)
			if debugtables.value then
				if gametype == GT_WAREDEBUG then
					recursiveTableContents(v,{x=4,y=20},WARE)
					recursiveTableContents(v,{x=4,y=120},p.wareperm)
					recursiveTableContents(v,{x=4,y=160},p.waremem)
				else
					v.drawString(4,20,"ware_debug only available under debugware",V_ALLOWLOWERCASE,"small")
				end
			end
			
			if WARE.state >= WS_ROUNDSETUP and WARE.state < WS_END then
				/*
				local spdx,spdy = 8*FRACUNIT,(200-32)*FRACUNIT
				local spdflags = V_SNAPTOLEFT|V_SNAPTOBOTTOM
				v.drawScaled(spdx,spdy,FRACUNIT/2,v.cachePatch("SPDARRW1"), spdflags)
				
				--local spdstr = "x1.0"
				local mul = FixedMul(100*FRACUNIT, WARE.spdcoef)/FRACUNIT
				local mulI,mulF = mul/100,mul%100 + (WARE.speed > 0 and 1 or 0)
				local spdstr = "x"..mulI.."."..mulF
				drawStringMkII(v,spdx+8*FRACUNIT,spdy-8*FRACUNIT,
				spdstr,FONT_CONSOLE2,
				spdflags,{valign="center",align="center",color=SKINCOLOR_SAPPHIRE,style=FS_FIXED,scale=FRACUNIT/4*3})
				*/
				
				--local scol = SKINCOLOR_YELLOW
				local scol = scorecolor[gametype]
				local scx,scy = (320/2)*FRACUNIT,(8)*FRACUNIT
				local scflags = V_SNAPTOTOP
				drawStringMkII(v,scx,scy,
					"Score",
					FONT_CONSOLE2,V_SNAPTOTOP,
					{valign="center",align="center",color=scol,style=FS_FIXED}
				)
				local worth = WARE.boss and 5 or 1
				local lockedwin = WARE.state == WS_ROUND and p.waremem.won and p.waremem.wonlock
				drawStringMkII(v,scx,scy+12*FRACUNIT,
					p.wareperm.score..(lockedwin and "+"..worth or ""),
					FONT_CONSOLE2,V_SNAPTOTOP,
					{valign="center",align="center",color=scol,scale=FRACUNIT*2,style=FS_FIXED}
				)
			end
			
			if WARE.state == WS_WAITPLAYERS then
				local debugcol = v.getColormap(TC_RAINBOW, SKINCOLOR_GREEN)
				local col = gametype == GT_WAREDEBUG and debugcol or nil
				//local debugcol = v.getColormap(TC_RAINBOW, SKINCOLOR_GREEN)
				v.drawScaled(160*FRACUNIT, 4*FRACUNIT, FRACUNIT/2, v.cachePatch("WARELOGO"), V_SNAPTOTOP, col)
				if gametype > GT_WARE then
					local custom = gametype == GT_WARECUSTOM
					local more = custom and "Custom" or "Debug"
					v.drawString(160, 60, more.." edition", (custom and V_YELLOWMAP or V_GREENMAP)|V_ALLOWLOWERCASE|V_SNAPTOTOP, "center")
				end
			end
		end,
		scorehud = function(v,p,c)
			local scx,scy = (320/2)*FRACUNIT,(8)*FRACUNIT
			local scflags = V_SNAPTOTOP
			drawStringMkII(v,scx,scy,
				"Round "..(WARE.round).." of "..WARESETTING(STG_ROUNDS),
				FONT_CONSOLE2,V_SNAPTOTOP,
				{valign="center",align="center",color=SKINCOLOR_JET,style=FS_FIXED}
			)
			
			local mul = FixedMul(100*FRACUNIT, WARE.spdcoef)/FRACUNIT
			local mulI,mulF = mul/100,mul%100 + (WARE.speed > 0 and 1 or 0)
			local spdstr = "x"..mulI.."."..mulF
			drawStringMkII(v,scx,scy+8*FRACUNIT,
			spdstr,FONT_CONSOLE2,
			V_SNAPTOTOP,{valign="center",align="center",color=SKINCOLOR_SAPPHIRE,style=FS_FIXED,scale=FRACUNIT/4*3})
		end,
		think = function()
			WARE.time = $+1
			WARE.muscoef = FRACUNIT + WARE.speed * (FRACUNIT/10) // This is just for the jingle stuff
			WARE.spdcoef = FRACUNIT + WARE.speed * (3*FRACUNIT/20)
			-- x% of y is x * y / 100
			//WARE.fractime = WARE.time * WARE.spdcoef
			
			WARE.scaledtime = (WARE.time * WARE.spdcoef) / FRACUNIT
			WARE.mustime = (WARE.time * WARE.muscoef) / FRACUNIT
			
			local mgame
			if WARE.state == WS_ROUND then
				mgame = WARE_GetMinigame(WARE.curgame)
			end
			
			local c = 0
			local lc = 0
			for p in players.iterate do
				if not p.wareperm or p.wareperm.init == nil then
					WAREPLY_INIT(p)
				end
				
				if p.spectator then p.wareperm.inplay = false end
				
				if WARE_PlayerInField(p) then
					c = $+1
					if p.playerstate ~= PST_DEAD then lc = $+1 end
					local sk = skins[p.mo.skin]
					for i = 1,#scaleply do
						local t = scaleply[i]
						if t[2] == SCALE_NONE then
							p[t[1]] = sk[t[1]]
						elseif t[2] == SCALE_PART then
							local part = FixedMul(WARE.spdcoef-FRACUNIT, t[3])+FRACUNIT
							p[t[1]] = FixedMul(sk[t[1]], part)
						end
					end
					p.score = p.wareperm.score
				end
				if WARE.state ~= WS_ROUND and WARE.state ~= WS_END then
					p.weapondelay = 2
					p.rings = 0
				end
				if p.playerstate == PST_DEAD then
					if mgame and (mgame.deathlose == nil or mgame.deathlose == true) and WARE_PlayerInPlay(p) then
						WARE_PlayerLose(p,true)
					end
					p.deadtimer = 1
				end
			end
			WARE.playercount = c
			WARE.livingcount = lc
		end,
		switchin = function()
			WARE.time = 0
			WARE.scaledtime = 0
			WARE.mem = {}
			WARE_ForEachPlayer(function(p)
				if p.playerstate == PST_DEAD then
					p.playerstate = PST_REBORN
					WARE_RestorePlayers()
				end
				
			end)
			if WARE.state ~= WS_POSTROUND then
				WAREPLY_CLEANUP()
				WAREPLY_PLAYNOW()
			end
			COM_BufInsertText(server, "restrictskinchange yes")
		end,
		switchout = function()
			WARE_ForEachPlayer(function(p)
				local coolpow = {
					pw_invulnerability,pw_sneakers,pw_flashing,pw_shield,
					pw_gravityboots,
					pw_infinityring,pw_automaticring,pw_bouncering,
					pw_scatterring,pw_grenadering,pw_explosionring,pw_railring
				}
				for i = 1,#coolpow do
					p.powers[coolpow[i]] = 0
				end
				p.score = 0
				p.currentweapon = 0
				p.ringweapons = 0
			end)
			for m in mobjs.iterate() do
				if m.type == MT_FLINGRING then P_RemoveMobj(m) end
			end
		end
	},
	// Non-global think states can *return* a value, meaning the state is shifted to the specified one
	[WS_WAITPLAYERS] = {
		switchin = function()
			WARE_RESET()
			print("\142SRB2Ware "..WAREVERSION..", developed by Rapidgame7.")
			--print("\142Still in beta.")
		end,
		gamehud = function(v,p,c)
			local ravioli = FixedAngle(leveltime*6*FRACUNIT)
			local r = sin(ravioli)*8
			local under = cos(ravioli) < 0
			local pc,cv = WARE.playercount,WCV.waitplayers.value
			local starting = pc >= cv
			//v.drawString(320/2,(160/2)+r,"Waiting for players...", V_SNAPTOTOP|V_ALLOWLOWERCASE, "center")
			
			local function drawme()
				local str = "2/12"
				
				if not starting then
					str = (cv-pc).." more..."
				else
					str = "Starting soon!"
				end
				if gametype == GT_WAREDEBUG and WCV.instastart.value then
					str = "FORCEFULLY STARTING ON JOIN"
				end
				drawStringMkII(v,rndx,stty,
					str,
					FONT_CONSOLE2,V_SNAPTOTOP,
					{valign="center",align="center",color=SKINCOLOR_GOLD,style=FS_FIXED}
				)
			end
			if under then drawme() end
			drawStringMkII(v,rndx,stty+r,
				"Waiting for players...",
				FONT_CONSOLE2,V_SNAPTOTOP|(starting and V_50TRANS or 0),
				{valign="center",align="center",color=SKINCOLOR_JET,style=FS_FIXED}
			)
			if not under then drawme() end
		end,
		think = function()
			WARE_PlayMusic("WJWAIT",true)
			local mem = WARE.mem
			if mem.waited == nil then mem.waited = 0 end
			mem.waited = $+1
			if WARE.playercount < WCV.waitplayers.value then // At least this many players
				mem.waited = 0
			end
			if mem.waited > TICRATE*5 then return WS_WARMUP end
			if gametype == GT_WAREDEBUG and WCV.instastart.value and WARE.playercount > 0 then return WS_PREROUND end
			P_RandomByte() // burn
		end
	},
	
	[WS_WARMUP] = {
		gamehud = function(v,p,c)
			drawStringMkII(v,rndx,stty,
				"Get ready!",
				FONT_CONSOLE2,V_SNAPTOTOP,
				{valign="center",align="center",color=SKINCOLOR_JET,style=FS_FIXED}
			)
		end,
		think = function()
			WARE_PlayMusic("WJSPCL")
			if WARE.time > 14*TICRATE then
				return WS_PREROUND
				// Let's begin!
			end
		end
	},
	
	[WS_ROUNDSETUP] = {
		gamehud = function(v,p,c)
			local tic2 = TICRATE/2
			local bnc = abs(sin(FixedAngle(WARE.mustime*10*FRACUNIT)))
			--local inc = FRACUNIT/16*(WARE.time/tic2)
			--bnc = FixedMul(bnc,FRACUNIT+inc)
			local txt,col = "Speed up!",SKINCOLOR_SAPPHIRE
			if WARE.boss then txt,col = "Boss time!",SKINCOLOR_RED end
			drawStringMkII(v,prpx,prpy+16*FRACUNIT,
				txt,
				FONT_CONSOLE2,V_SNAPTOTOP,
				{valign="center",align="center",color=col,scale=FRACUNIT*5/2+bnc,style=FS_FIXED}
			)
			if WARE.boss then
				drawStringMkII(v,prpx,prpy+32*FRACUNIT,
					"Worth 5 points!",
					FONT_CONSOLE2,V_SNAPTOTOP,
					{valign="center",align="center",color=col,scale=FRACUNIT+bnc/3,style=FS_FIXED}
				)
			end
		end,
		switchin = function()
			if WARE.boss then
				WARE.speed = 0
			end
		end,
		switchout = function()
			if not WARE.boss then
				WARE.speed = $+1
			end
		end,
		think = function()
			local limit = TICRATE*7+8
			if WARE.boss then
				WARE_PlayJingle("WJBOS", p)
				limit = TICRATE*4-8
			else
				WARE_PlayJingle("WJSPD", p)
			end
			if WARE.mustime > limit then
				return WS_PREROUND
			end
		end,
	},
	
	[WS_PREROUND] = {
		switchin = function()
			WARE.round = $+1 // No idea why wasn't this here before
			if gametype == GT_WAREDEBUG and WCV.roundless.value then WARE.round = 0 end
		end,
		gamehud = function(v,p,c)
			drawStringMkII(v,rndx,rndy,
				"Round",
				FONT_CONSOLE2,V_SNAPTOTOP,
				{valign="center",align="center",color=SKINCOLOR_JET,style=FS_FIXED}
			)
			local bnc = abs(sin(FixedAngle(WARE.mustime*10*FRACUNIT)))
			--print(bnc)
			local roundstr = WARE.round
			if gametype == GT_WAREDEBUG and WCV.roundless.value then roundstr = "X" end
			drawStringMkII(v,rndx,rndy+12*FRACUNIT,
				roundstr,
				FONT_CONSOLE2,V_SNAPTOTOP,
				{valign="center",align="center",color=SKINCOLOR_JET,scale=FRACUNIT*2+bnc/2,style=FS_FIXED}
			)
		end,
		think = function()
			WARE_PlayJingle("WJINT", p)
			if WARE.mustime > TICRATE*4 then
				if CV_FindVar("forceskin").string:lower() ~= "none" then
					WARE.eggreason = "forceskin"
					return WS_EGG
				end
				if WARE.playercount > 0 then
					return WS_ROUND
				else
					print("No players in-game. Waiting for players...")
					return WS_WAITPLAYERS
				end
			end
		end,
	},
	
	[WS_ROUND] = {
		switchin = function()
			// Pick a minigame!
			--WAREPLY_CLEANUP()
			
			//WARE.round = $+1
			local r,rr = WARE_Raffle()
			if not WARE.deluxe then print("Picked minigame "..r) end
			WARE.curgame = WARE_FindMinigame(r)
			local mgame = WARE_GetMinigame(WARE.curgame)
			
			for p in players.iterate do if WARE_PlayerInField(p) then
				P_ResetPlayer(p)
				p.mo.state = S_PLAY_STND
				
				if mgame.skin then
					R_SetPlayerSkin(p, mgame.skin)
					WARE_ForcePlayerSkin(p, mgame.skin)
				end
				if mgame.prompt then
					p.waremem.prompt = mgame.prompt
				end
				
			end end
			
			if mgame.spawnpoint then
				WARE_WarpPlayers(mgame.spawnpoint,mgame.positioning)
			end
			if mgame.skynum ~= nil then
				P_SetupLevelSky(mgame.skynum)
			end
			if mgame.music then WARE_PlayMusic(mgame.music,mgame.musicloop) end
			if mgame.fStart ~= nil then mgame.fStart() end
			// 
			
			
		end,
		gamehud = function(v,p,c)
			local mgame = WARE_GetMinigame(WARE.curgame)
			if mgame.fHud ~= nil then mgame.fHud(v,p,c) end
			
			local bflags = V_SNAPTOBOTTOM|V_SNAPTOLEFT
			
			local timelimit = mgame.timelimit
			local time = WARE.scaledtime
			local timeleft = timelimit-time
			--v.drawString(4,200-12,mgame.timelimit-WARE.time, bflags)
			
			--if mgame.prompt and WARE.scaledtime < TICRATE*8 then
			if p.waremem.prompt and WARE.scaledtime < TICRATE*8 then
				local prompt = p.waremem.prompt
				if type(prompt) == "string" then prompt = {prompt} end // wow hack
				
				local chungus = max(FRACUNIT, FRACUNIT+(5-WARE.scaledtime)*FRACUNIT/2)
				
				for lineix = 1,#prompt do
					local line = prompt[lineix]
					if WARE.deluxe then
						local newline = ""
						for i = 1,#line do
							local chr = line:sub(i,i)
							local nm = string.byte(string.lower(chr))
							if nm >= 97 and nm <= 122 then
								newline = $..string.char(v.RandomRange(97,122))
							else
								newline = $..chr
							end
						end
						line = newline
					end
					drawStringMkII(v,prpx,prpy+8*(lineix-1)*FRACUNIT,
						line,
						FONT_CONSOLE2,V_SNAPTOTOP,
						{valign="center",align="center",scale=chungus,color=SKINCOLOR_JET,style=FS_FIXED}
					)
				end
			end
			
			local perc = (320-24)*FRACUNIT / timelimit * timeleft
			
			for i = 24,320,8 do
				if i > perc/FRACUNIT+24 then break end
				v.draw(i, 200-16, v.cachePatch("BOMBFUSE"),bflags)
			end
			
			local bina = timeleft/8%2 == 0
			v.drawScaled(24*FRACUNIT+perc,(200-11)*FRACUNIT,bina and FRACUNIT or FRACUNIT*2/3,v.cachePatch("BOMBFIRE"), bflags)
			
			local winstate = (p.waremem.won and 1 or 0) + (p.waremem.wonlock and 2 or 0)
			local wincol = winstate == 0 and SKINCOLOR_CRIMSON // Not locked, losing
			            or winstate == 1 and SKINCOLOR_FOREST  // Not locked, winning
						or winstate == 2 and SKINCOLOR_RED     // Locked, lost
						or winstate == 3 and SKINCOLOR_EMERALD // Locked, won
			//v.draw(0,200,v.cachePatch("BLUHED"), bflags, v.getColormap(-1, wincol))
			v.drawScaled(0,200*FRACUNIT,FRACUNIT*32/46,v.cachePatch("BLUDET"), bflags, v.getColormap(-1, wincol))
			
			local txtn = timeleft/TICRATE+1
			if txtn <= 3 then
				if txtn < 0 then txtn = "!?" end // Just in case
				local cool = funnycolor[txtn] or SKINCOLOR_GREY
				local bump = FRACUNIT*5/2
				local the = 6
				bump = max(1, $/the*min(TICRATE - (WARE.revscaledtime % TICRATE), the))
				drawStringMkII(v,(16)*FRACUNIT,(200-16)*FRACUNIT,
				//timeleft/TICRATE+1,FONT_CONSOLE2,
				txtn,FONT_CONSOLE2,
				bflags,{valign="center",align="center",color=cool,style=FS_FIXED,scale=bump})
			end
			
			if mgame.weaponrings then
				hud.enable("weaponrings")
			end
		end,
		think = function()
			local mgame = WARE_GetMinigame(WARE.curgame)
			--if mgame.skin then
			for p in players.iterate do if WARE_PlayerInField(p) then
				local wm = p.waremem
				if wm.forceskin then p.mo.skin = wm.forceskin end
				if wm.forcecolor then p.mo.color = wm.forcecolor end
			end end
			--end
			
			if WCV.temposhift.value and not mgame.notemposhift and WARE.speed > 0 then
				// EXPERIMENTAL
				local mustic = 1000*FRACUNIT / 35
				S_SetMusicPosition(FixedMul(mustic, WARE.spdcoef)*WARE.time/FRACUNIT)
			end
			
			local fastend = true
			WARE_ForEachPlayer(function(p)
				if WARE_PlayerInPlay(p) then
					if WARE_PlayerCompeting(p) then fastend = false end
					if p.waremem.wonlock then
						local m = p.mo
						if p.waremem.won then
							if leveltime % (TICRATE/7) == 0 then
								local sk = P_SpawnMobjFromMobj(m,0,0,0,MT_IVSP)
								--sk.scale = m.scale
							end
						else p.powers[pw_flashing] = TICRATE end
					end
				end
			end)
			if fastend then
				// If there are more than 3 seconds on the clock, accounting for speed,
				// bring it down to 3 seconds
				// because this is a counter going up,
				// we need to account for timelimit
				local scaledthree = FixedMul(3*TICRATE, WARE.spdcoef)
				WARE.time = max($, FixedDiv(mgame.timelimit-scaledthree,WARE.spdcoef))
			end
			WARE.revscaledtime = mgame.timelimit - WARE.scaledtime
			if WARE.scaledtime > mgame.timelimit then
				return WS_POSTROUND
			end
			
			local mem = WARE.mem
			local before = mem.pastsecond
			mem.pastsecond = WARE.revscaledtime / TICRATE
			if mem.pastsecond < 3 and mem.pastsecond ~= before then
				S_StartSound(nil, _G["sfx_watik"..((mem.pastsecond%2)+1)])
			end
			
			if mgame.fThink ~= nil then mgame.fThink() end
			
		end,
		switchout = function()
			local mgame = WARE_GetMinigame(WARE.curgame)
			if mgame.fEnd ~= nil then mgame.fEnd() end
			if mgame.restoreonend or (mgame.spawnpoint and mgame.restoreonend == nil) then
				WARE_BackToOrigin()
				WARE_RestorePlayers()
			end
			WARE_ForEachPlayer(function(p)
				p.mo.color = p.skincolor
			end)
			P_SetupLevelSky(1)
		end,
	},
	
	[WS_POSTROUND] = {
		switchin = function()
			local mem = WARE.mem
			mem.wtxt = randomChoose(winmsg)
			mem.ltxt = randomChoose(lostmsg)
			for p in players.iterate do
				if p.waremem.won then
					local s = 1
					if WARE.boss then s = 5 end
					p.wareperm.score = $+s
				end
			end
		end,
		gamehud = function(v,p,c)
			local str,col
			if p.waremem.won then
				str,col = WARE.mem.wtxt,SKINCOLOR_EMERALD
			else
				str,col = WARE.mem.ltxt,SKINCOLOR_RED
			end
			local bnc = abs(sin(FixedAngle(WARE.mustime*10*FRACUNIT)))
			if not p.waremem.won then bnc = ($/4) end
			drawStringMkII(v,prpx,prpy+16*FRACUNIT,
				str,
				FONT_CONSOLE2,V_SNAPTOTOP,
				{valign="center",align="center",color=col,scale=FRACUNIT*5/2+bnc,style=FS_FIXED}
			)
		end,
		think = function()
			for p in players.iterate do
				if p.waremem.won then
					--WARE_PlayJingle
					WARE_PlayJingle("WJWIN", p)
				else WARE_PlayJingle("WJFAI", p) end
			end
			if WARE.mustime > TICRATE*2 then
				if WARE.round >= WARESETTING(STG_ROUNDS) then return WS_END end // Finished all rounds, game over
				if WARE.round > 0 then
					local toboss = WARESETTING(STG_TOBOSS)
					local tospeed = WARESETTING(STG_TOSPEED)
					local bossnow,speednow = false,false
					if toboss > 0 and WARE.round % toboss == 0 then bossnow = true end
					if tospeed > 0 and WARE.round % tospeed == 0 then speednow = true end
					WARE.boss = bossnow
					if bossnow or speednow then
						return WS_ROUNDSETUP
					else
						return WS_PREROUND
					end
				end
			end
		end,
	},
	
	[WS_END] = {
		switchin = function()
			local winners = {}
			local highest = 0
			
			WARE_ForEachPlayer(function(p)
				if p.wareperm.score > highest then
					highest = p.wareperm.score
					winners = {}
				end
				if p.wareperm.score == highest then
					table.insert(winners, p)
				end
			end)
			
			local s1 = "win txt"
			local s2 = ", with "..highest.." points!"
			local recount = ""
			for i = 1,#winners do
				local n = winners[i].name
				recount = $..(i > 1 and (i == #winners and " and " or ", ") or "").."\130"..n.."\128"
			end
			if #winners == 1 then s1 = "The winner is " else s1 = "The winners are " end
			chatprint("\x03"..WARETAG.." "..s1..recount..s2)
			
			WARE.mem.winners = winners
		end,
		gamehud = function(v,p,c)
			local bnc = abs(sin(FixedAngle(WARE.time*10*FRACUNIT)))/4
			local txt,col = "Speed up!",SKINCOLOR_SAPPHIRE
			if WARE.boss then txt,col = "Boss time!",SKINCOLOR_RED end
			drawStringMkII(v,prpx,(200-32)*FRACUNIT,
				"Game over!",
				FONT_CONSOLE2,V_SNAPTOTOP,
				{valign="center",align="center",color=SKINCOLOR_YELLOW,scale=FRACUNIT*2+bnc,style=FS_FIXED}
			)
			hud.enable("weaponrings")
		end,
		think = function()
			WARE_PlayMusic("WJOVER")
			local mem = WARE.mem
			
			local winners = mem.winners
			for ix = 1,#winners do
				local p = winners[ix]
				p.ringweapons = 63 // all
				for i = 15,20 do
					p.powers[i] = P_RandomRange(100,999)
				end
			end
			
			if WARE.time > TICRATE*12 then
				return WS_WAITPLAYERS
			end
		end,
	},
	
	[WS_EGG] = {
		switchin = function()
			local r = WARE.eggreason
			if r ~= nil then
				local c = "\138"
				if r == "forceskin" then
					print(c.."forceskin must be disabled for srb2ware to work properly.")
				end
			end
		end,
		gamehud = function(v,p,c)
			v.drawFill(nil, nil, nil, nil, 31)
			v.draw(0,0,v.cachePatch("PINGUMAD"))
		end,
	}
}
local GLOBALSTATE = WARESTATES["global"]
local function CASTSTATE(kind,...) // SHOULD BE CALLED ONLY ONCE PER THINKER
	local st = WARE.state
	if GLOBALSTATE[kind] ~= nil then GLOBALSTATE[kind](...) end
	if WARESTATES[st] ~= nil and WARESTATES[st][kind] ~= nil then
		return WARESTATES[st][kind](...)
	else
		--print("STATE WITH NO RUNNABLE FUNCTION")
	end
end

local function CHANGESTATE(sss)
	WARE.SWITCHOUT = true
	CASTSTATE("switchout")
	WARE.SWITCHOUT = nil
	WARE.state = sss
	WARE.SWITCHIN = true
	CASTSTATE("switchin")
	WARE.SWITCHIN = nil
end

local phooks = {
	// "ThinkFrame", lmao we already have this one
	"PlayerSpawn",
	"PlayerMsg",
	--"TeamSwitch", // Eh...
	--"ViewpointSwitch", // Fuck you
	"HurtMsg",
	"SeenPlayer",
	"ShieldSpecial",
}
local mhooks = {
	// Mobj as first argument
	"ShouldDamage",
	"TouchSpecial",
	"MobjSpawn",
	"MobjCollide",
	"MobjMoveCollide",
	"MobjFuse",
	"MobjThinker",
	"MobjDamage",
	"MobjDeath",
	"MobjRemoved",
	"MobjMoveBlocked",
}
local function _gFormula()
	return ISWARE() and WARE.prepped and WARE.state == WS_ROUND and not (WARE.SWITCHOUT or WARE.SWITCHIN)
end
local function _pFormula(p)
	return _gFormula() and p and p.valid and p.mo and p.mo.valid and not p.spectator and p.wareperm.inplay
end
local function _mFormula(m)
	return _gFormula() and m and m.valid
end

for i = 1,#phooks do
	local hkName = phooks[i]
	local hkEName = "h"..hkName
	addHook(hkName, function(p, ...) if _pFormula(p) then
		--print(hkName)
		local cm = WARE_GetMinigame(WARE.curgame)
		if cm[hkEName] ~= nil then
			return cm[hkEName](p, ...)
			--print("AKAAdsgal")
		end
	end end)
end
for i = 1,#mhooks do
	local hkName = mhooks[i]
	local hkEName = "h"..hkName
	addHook(hkName, function(m, ...) if _mFormula(m) then
		local cm = WARE_GetMinigame(WARE.curgame)
		if hkName == "MobjCollide" or hkName == "MobjMoveCollide" then
			// Collision is fucking stupid, therefore
			// Encompass both collisions in one single multipurpose hook
			// If this exists, ignore the other collider hooks
			if cm["fCollide"] ~= nil then return cm["fCollide"](m, ...) end
		end
		if cm[hkEName] ~= nil then
			return cm[hkEName](m, ...)
		end
	end end)
end

addHook("MobjDamage", function(m, inf, src, dmg, dmgtype) if ISWARE() then
	local p = m.player
	local cg = WARE_GetMinigame(WARE.curgame)
	if cg and p and p.valid then
		if (cg.forcedeath or WARE.state == WS_END) and (dmgtype & DMG_INSTAKILL)==0 then
			// Force death is on but damage is not instakill? Instakill then
			P_DamageMobj(m,inf,src,dmg,dmgtype|DMG_INSTAKILL)
			return true // Well what the fuck am I supposed to do
		end
		if cg.nodeath and p.rings == 0 then
			S_StartSound(m, sfx_altdi1)
			P_DoPlayerPain(m.player, src, inf)
			return true
		end
	end
end end, MT_PLAYER)

addHook("ViewpointSwitch", function(p, np, forced) if ISWARE() then
	// Only change viewpoint if the target is alive
	return WARE_PlayerInPlay(np) and np.playerstate == PST_LIVE and not np.spectator
end end, MT_PLAYER)
addHook("TeamSwitch", function(p, team, fspec) if ISWARE() then
	if fspec and WARE.state == WS_ROUND then
		chatprintf(p, WARETAG.." You can't enter during a minigame!")
		return false
	end
end end, MT_PLAYER)

addHook("PreThinkFrame", function()
	for p in players.iterate do
		if not p.waremem then p.waremem = {} end
		if not p.wareperm then p.wareperm = {} end
	end
end)

addHook("ThinkFrame", function()
	if leveltime == 0 then WARE_CLEANUP() end
	if ISWARE() then
		if leveltime == 0 then CASTSTATE("switchin") end
		if not WARE.prepped then
			WARE.prepped = true
		end
		local sr = CASTSTATE("think")
		if sr ~= nil then
			CHANGESTATE(sr)
		end
	end
end)

hud.add(function(v,p,c)
if WARE and WARE.prepped then
	hud.disable("score")
	hud.disable("time")
	hud.disable("rings")
	hud.disable("lives")
	hud.disable("weaponrings")
	if p.waremem and p.wareperm then
		CASTSTATE("gamehud",v,p,c)
		if p.mo and p.mo.valid and not c.chase then
			local skeen = skins[p.mo.skin].realname
			v.drawString(320/2, 200-8, "Playing as "..skeen,V_SNAPTOBOTTOM|V_ALLOWLOWERCASE|V_50TRANS,"center")
		end
	end
end
end, "game")
hud.add(function(v,p,c)
if WARE and WARE.prepped then
	CASTSTATE("scorehud",v)
end
end, "scores")









// Admin only debug commands
// Must be here because I'm a fucking idiot
local function isdebug()
	return gametype == GT_WAREDEBUG
end
local functionality = {
	"wd_sn", function(p) CHANGESTATE(WS_PREROUND) end,
	"wd_sr", function(p,a) WARE.round = tonumber(a) or 0 end,
	"wd_ss", function(p,a) WARE.speed = tonumber(a) or 0 end,
	"wd_se", function(p) CHANGESTATE(WS_END) end,
	"wd_qt", function(p,a) COM_BufInsertText(server, "ware_force "..a);CHANGESTATE(WS_PREROUND) end,
}
for i = 1,#functionality,2 do
	local cmd = functionality[i]
	local fn = functionality[i+1]
	COM_AddCommand(cmd, function(p,...)
		if isdebug() then
			fn(p,...)
		else CONS_Printf(p, "This command can only be used in DebugWare!") end
	end, 1)
end
//COM_AddCommand("sn", , 1)




